;; Copyright 2009, 2010, 2013 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------

(defun align-let-sexp (start end)
  "`align-let' all forms between START and END.
A `let' form which starts within the region but extends beyond
END is aligned."
  (save-excursion
    (let ((bounds (bounds-of-thing-at-point 'sexp)))
      (if bounds
          (align-let-region (car bounds) (cdr bounds))))))

(setq debug-on-quit t)
(setq debug-on-error nil)

(align-let-region (point-min) (point-max))

(defun align-let-buffer ()
  (interactive)
  (align-let-region (point-min) (point-max)))

last-err
(setq last-err (error-message-string err))

(progn
  (add-to-list 'load-path (expand-file-name "~/lisp"))
  (add-to-list 'load-path (expand-file-name ".."))
  (load "tests/t-align-let.el")
  (setq debug-on-error t)
  (my-run-test))

(progn
  (add-to-list 'load-path (expand-file-name "~/lisp"))

  (autoload 'align-let-keybinding "align-let" nil t)
  (add-hook 'emacs-lisp-mode-hook 'align-let-keybinding)
  (add-hook 'scheme-mode-hook     'align-let-keybinding)

  (emacs-lisp-mode))

safe-local-variable-p
(find-file "d-align-let-localvar.el")
(setq align-let-spaces 5)

(let ((foo  1)   "abc" \?   ;; (let ((foo   2)) x)
      (bar      2))
  nil)

(let (()
      (quuxfjdksfjksdjfks
       3)
      (foo        1)
      (  bar 2)
      (            fjkdsfsdjkflasjfklsajfkdjaklfsdjla)
      fjkdsfsdjkflasjfklsajfkdjaklfsdjla)
  nil)

(customize-variable 'emacs-lisp-mode-hook)

(progn
  (require 'scheme)
  (customize-variable 'scheme-mode-hook)))







(let ((x         jfkds)
      (y fjkda))
  #f)


  (and-let* (x
             (x  1)
             (xy 2))
    




(defun foo ()
  (and-let* (x
             (x  1)
             (xy 2))
    



(let ((foo   1)  ;; foo 
      (bar        2)   ;; bar
      quuxxxxxxx)
  nil)

(let ((foo 1)
      (
       bar 2
           )
      ;; fjdks
      )
  nil)


;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------
(let (found)
  (mapatoms (lambda (symbol)
              (and (boundp symbol)
                   (equal 268435455 (symbol-value symbol))
                   (push symbol found))))
  found)


;;-----------------
;; setq

(setq foo        1)
(setq foo 1 bar)
(setq foo 1 bar 2)
(setq foo       1
      bar------dfsjk
      2
      quux      99
      abc    1)
(align-let-doelems 'setq (lambda () (print (point))))

(and-let* (keyword))
(let-optional (keyword) (bindings))

(put 'let-optional 'align-let 2) ;; Scheme

;;-----------------

(featurep 'align-let)
(require 'align-let)
(unload-feature 'align-let)
(fboundp 'align-let)
(symbol-function 'align-let)



;;-----------------
;; stuff at eob
      
(setq debug-on-quit nil)
(setq debug-on-error t)
(let ((foo   1)
      (z
