;; Copyright 2009, 2010, 2013 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------

(add-to-list 'load-path (expand-file-name ".."))
(load "localedef-overlay.el")
(require 'un-define)
(localedef-overlay-decode-ucs "2022")
(localedef-overlay-decode-ucs "D800")
(localedef-overlay-decode-ucs "0041")
(localedef-overlay-decode-ucs "007E")
(localedef-overlay-decode-ucs "00F7")
(decode-coding-string (string 247) 'iso-8859-1)
(insert (string (decode-char 'ucs (string-to-number "D800" 16))))
(insert (string (decode-char 'ucs (string-to-number "2022" 16))))
(decode-coding-string (string-make-unibyte (string 226 128 162)) 'utf-8)
(decode-coding-string [226 128 162] 'utf-8)
(localedef-overlay-mode)

(progn
  (require 'un-define)
  (make-char 'utf-16-be 8226))
(pp (charset-list) (current-buffer))
(katakana-jisx0201 chinese-cns11643-6 chinese-isoir165 control-1 sisheng vietnamese-viscii-upper chinese-big5-2 japanese-jisx0208-1978 latin-iso8859-9 chinese-cns11643-3 latin-iso8859-2 ethiopic latin-iso8859-16 korean-ksc5601 latin-jisx0201 latin-iso8859-4 chinese-cns11643-5 arabic-iso8859-6 latin-iso8859-1 chinese-cns11643-1 arabic-1-column greek-iso8859-7 chinese-gb2312 thai-xtis thai-tis620 latin-iso8859-3 chinese-cns11643-7 latin-iso8859-14 vietnamese-viscii-lower japanese-jisx0208 chinese-cns11643-2 cyrillic-iso8859-5 ascii hebrew-iso8859-8 arabic-2-column chinese-big5-1 japanese-jisx0212 chinese-cns11643-4 latin-iso8859-15 arabic-digit ipa)


;; <U0103>  <U0233>
;; <U1234>
;; <U00A4>
;; <U0041>

(let ((str "007E"))
  '(decode-coding-string
          (string (string-to-number (substring str 0 2) 16)
                  (string-to-number (substring str 2 2) 16))
          'utf-16-be)
  '(string-to-number (substring str 0 2) 16)
  '(string-to-number  16)
  (substring str 2 2))

;; (defun localedef-chars ()
;;   "Put an overlay on <U20FF> etc forms with their unicode chars."
;;   (interactive)
;;   (save-excursion
;;     (goto-char (point-min))
;;     (while (re-search-forward "<\\(U[0-9A-F]\\{4\\}\\)>" nil t)
;;       (let ((overlay (make-overlay (match-beginning 0) (match-end 0))))
;;         (overlay-put overlay 'display
;;                      (string (decode-char 'ucs (string-to-number
;;                                                 (match-string 1) 16))))))))

;; (defun localedef-font-lock ()
;;   (interactive)
;;   (font-lock-add-keywords
;;    major-mode
;;    '(("<\\(U[0-9A-F]\\{4\\}\\)>" 0 (list 'face nil display "X")))))
;;

(progn
  (require 'overlay)
  (let ((overlay (make-overlay (- (point-max) 5) (point-max)
                               (current-buffer)
                               t))) ;; front-advance, so new not included
    (overlay-put overlay 'display "hello")))

(let ((overlays (overlays-at (1- (point-max)))))
  (overlay-properties (car overlays)))


(make
