;; Copyright 2010 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(require 'cl)

(defun my-count-args ()
  (save-excursion
    (let ((count 0))
      (while (condition-case nil
                 (goto-char (scan-sexps (point) 1))
               (error nil))
        (incf count))
      count)))

(defun my-grep-buffer ()
  (save-excursion
    (goto-char (point-min))
    (while (re-search-forward "(add-hook\\(\\s-\\|$\\)" nil t)
      (and (save-excursion
             (not (search-backward ";;" (point-at-bol) t)))
           (>= (my-count-args) 4)
           (save-excursion
             (goto-char (point-min))
             (not (re-search-forward "(\\(gnus-\\)?make-local-hook" nil t)))

           (let (;; (filename buffer-file-name)
                 (line     (count-lines (point-min) (point)))
                 (column   (current-column)))
             (with-current-buffer (get-buffer-create "*grep*")
               (insert (format "%s:%s:%s: add-hook\n"
                               filename line column))))))))

(defun my-grep-file (filename)
  (require 'lisp-mnt)
  (lm-with-file filename
    (my-grep-buffer)))

(defun my-grep (&rest wildcards)
  (kill-buffer (get-buffer-create "*grep*"))
  (switch-to-buffer "*grep*")
  (insert "\n")
  (dolist (wildcard wildcards)
    (dolist (filename (file-expand-wildcards wildcard))
      (my-grep-file filename)))
  (goto-char (point-min))
  (compilation-mode))

(my-grep "/usr/share/emacs/site-lisp/*.el"
         "/usr/share/emacs/site-lisp/*/*.el"
         "/usr/share/emacs/site-lisp/*/*/*.el")

(my-grep "/down/el/*.el")
(my-grep "/down/ding/gnus/lisp/*.el")

(my-grep "/usr/share/xemacs-21.4.22/lisp/*.el.gz"
         "/usr/share/xemacs-21.4.22/lisp/*/*.el.gz")
(my-grep "/usr/share/xemacs21/xemacs-packages/lisp*.el.gz"
         "/usr/share/xemacs21/xemacs-packages/lisp/*/*.el.gz")

                   ;; "/usr/share/emacs/site-lisp/*/*.el"



;;--------------------------
(add-hook 'kill-buffer-hook (lambda () (message "bye")))
