;; Copyright 2014 Kevin Ryde

;; This file is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; This file is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with this file; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(defun my-texinfo-no-auto-fills ()
  "Add `auto-fill-inhibit-regexp' to not split @def or @multitable lines.
An @deffn or @multitable command just be kept all on one line
\(unless an @ used to escape the newline).  This has been
incorporated in Emacs and XEmacs 21 up and so is needed only for
Emacs 20 and earlier."
  (parasep-add-to-regexp-var 'auto-fill-inhibit-regexp
                             "^@\\(def\\|multitable\\)"))

(add-hook 'texinfo-mode-hook 'my-texinfo-no-auto-fills)
